
Object sc_1
  class Scene,
  with
	number 1,
	begin_scene [ rock;
		print "^ ,  .      ,       .    .              ,        .^^";
		print ",      .       ,     .         .^";
		switch (rock) {
			-1, -2: ! boom/splat
				"    ? []";
			1:
				move activeplayer to EndOfAlley;
				self.variant = 1;
			2:
				move activeplayer to EndOfAlley;
				move lockpick to activeplayer;
				self.variant = 2;
		}
	],
	end_scene [ rock subrock;
		subrock = 0;
		switch (rock) {
			-1, -2:
				"     ? []";
			-3: ! security door open
				" ,   . ! []";
			1:
				SetQuestion(q1_1);
			2:
				move lockpick_model to Himself;
				SetQuestion(q1_3);
			3:
				lockpick.work_target = nothing;
				move lockpick to activeplayer; ! after successful use
				SetScene(sc_2);
		}
	],
	door_attempts 0;
	
Object q1_1
  class Question,
  with
	query "^@<<  , --  . --    ,     ,            ,      .    ,     ,    ,    .     ,   ,      .   ?@>>",
	time_limit 5,
	answer_yes [; 
		num_helpfuls++;
		print "  ,     .   .        .^";
		BeginScene(1);
	],
	answer_no [;
		num_blatant_lies++;
		print "      . @<< .   .   --";
		SetQuestion(q1_2);
	],
	answer_wait [;
		num_stupids++;
		print "         . @<<  --";
		SetQuestion(q1_2);
	];

Object q1_2
  class Question,
  with
	query "        .     ,        ,   ,      .    . ...  ?@>>",
	time_limit 6,
	daemon [;
		if (self.number == 3) {
			print "^@<< ?@>>^";
		}
	],
	answer_yes [;
		print "-, ,     .        .^";
		BeginScene(1);
	],
	answer_no [;
		print "  . @<<  .        @>>.    .^";
		BrainDrain();
	],
	answer_wait [;
		print "  . @<<  @>>.^^  .        .^";
		BeginScene(1);
	];

Object q1_3
  class Question,
  with
	query "^@<< , --  . --  ,         ,     .       @>>.      ,     . @<<, ,      ,   .     - ,   ,    .  , ?@>>^^   . -         .",
	time_limit 5,
	daemon [;
		if (self.number == 2) {
			print "^@<<-  ?   ?@>>       .^";
		}
	],
	answer_yes [;
		num_helpfuls++;
		print "@<<   @>>.       . @<<. ,  . ... @>>.^";
		BeginScene(2);
	],
	answer_no [;
		print "@<<?   ", (emphstring) "", ".    ,    ,    ,    .    ,        @>>.^";
		BeginScene(2);
	],
	answer_wait [;
		print "@<< ", (emphstring) "", ".    ,    ,    ,    .    ,        .    @>>.^";
		BeginScene(2);
	];

! ------------- The recall scene

Constant CantGoBrickWall "    .";

Object EndOfAlley " "
  with
	description [;
		print "   ,       .   ,    .";
		if (sc_1.variant == 0)
			print " ( :";
		else
			print " ( , ";
		"           ,     .)      .";
	],
	s_to MouthOfAlley,
	out_to MouthOfAlley,
	e_to outerdoor,
	in_to outerdoor,
	n_to "  .",
	cant_go CantGoBrickWall,
	u_to CantGoThatWay,
	d_to CantGoThatWay;

! Matched with outerdoorin, in t-2.
Object -> outerdoor "/ /"
  with
	name '' '' '' '' '',
	describe [;
		print "^   ,  ,    ";
		if (outerdoorplate hasnt general)
			print ".   ";
		".";
	],
	description "   ,   30  ,     .   ,   ,  ,  .       ,    ,  ,  .",
	door_dir e_to,
	door_to EndOfAlley,
	door_try [;
		print "   .^";
		return AttemptDoor();
	],
	before [;
		Open: 
			if (lockpick.work_target == outerdoorplate)
				print ".^";
			else
				print " , .^";
			return AttemptDoor();
		Close: 
			"  .";
		Attack, KnockOn: 
			print "      .     --        .^";
			return AttemptDoor();
		Push, Turn: 
			print "  .^";
			return AttemptDoor();
		Pull: 
			print "    ,       .^";
			return AttemptDoor();
		Listen: 
			print "    .^";
			return AttemptDoor();
		Touch, Rub: 
			print "    .^";
			return AttemptDoor();
		LookUnder: 
			print "   .^";
			return AttemptDoor();
	],
  has static door ~open female;

Object -> outerdoorplate "/ /  "
  with
	name '' '' '' '',
	description [;
		print " -       .      .    ,   -     ,     , .^";
		if (lockpick.work_target == self) {
			print "^   .^";
		}
		return AttemptDoor();
	],
	before [;
		Push, Pull, Turn, Rub, Touch: 
			print "  .^";
			return AttemptDoor();
		KnockOn, Attack: 
			print " .^";
			return AttemptDoor();
		Take: 
			print "   .^";
			return AttemptDoor();
	],
	daemon [;
		! started when the lockpick opens it.
		if (player == passiveplayer)
			print "^  . []^";
		if (self in location) {
			StopDaemon(self);
			if (self hasnt general)
				print "^    .^";
			else
				print "^ .^";
			EndScene(3);
		}
		else {
			! missed actual opening
			give self general;
		}
	],
  has scenery female;	! general means it's open, and you missed seeing it open.

Object MouthOfAlley "  "
  with
	description "       ,     .       ,    ,  , ,   .",
	n_to EndOfAlley,
	in_to EndOfAlley,
	s_to alleystreet,
	out_to alleystreet,
	cant_go CantGoBrickWall,
	u_to CantGoThatWay,
	d_to CantGoThatWay;

Object -> alleystreet "/"
  with
	name '' '',
	description " ,    ,       .              ,       - ,  .",
	door_dir s_to,
	door_to MouthOfAlley,
	door_try [;
		if (sc_1.variant > 0) {
			print "   .    .^";
			return AttemptDoor();
		}
		print "       ,        .^";
		EndScene(1);
		rtrue;
	],
  has door scenery female;

Object -> alleytraffic "/"
  with
	name '' '' '' '' '' '' '' '',
	description "   : ,    ,  .",
	life [;
		"    .";
	],
  has scenery animate male;
	
Object -> alleychildren "/"
  with
	name '' '' '' '' '' '',
	before [;
		"     .";
	],
	orders [;
		self.before();
		rtrue;
	],
  has scenery pluralname animate;
	
Object alleywalls "/ /"
  with
	name '' '' '',
	found_in EndOfAlley MouthOfAlley,
	description "    ,        ,    .",
	before [;
		Climb: "    .     .";
		Search: 
			if (location == EndOfAlley) 
				"   .         ,     .";
			else
				"   .";
		Attack, KnockOn: "  .";
		Listen: "    .";
		Touch, Rub: "    .";
		Enter: print_ret (string) CantGoBrickWall;
	],
  has scenery pluralname;

[ AttemptDoor;
	if (sc_1.variant ~= 1)
		rtrue;
	sc_1.door_attempts++;
	if (sc_1.door_attempts == 4)
		EndScene(2);
	rtrue;
];

